
########################################

rm(list=ls())
library(readxl)
library(ggplot2)
library(effects)
library(lme4)
library(lmerTest)

########################################

# Import data from data sheet
sketch<-as.matrix(read_excel("draw lmer data.xlsx",col_names=F))
d<-data.frame(x=1,y=1,rand="a")
for(i in 1:nrow(sketch)){
  for (j in 1:ncol(sketch)){
    if(!is.na(sketch[i,j])){
      d[nrow(d)+1,"x"]<-j
      d[nrow(d),"y"]<-i
      d[nrow(d),"rand"]<-sketch[i,j]
    }
  }
}; d<-d[2:nrow(d),]
d$y<-max(d$y)-d$y
plot(d[,c("x","y")])

########################################

# Visualize data
ggplot(d,aes(x=x,y=fit))+
  geom_point(data=d,aes(x=x,y=y,color=rand),size=8,alpha=.75)+xlab("X")+ylab("Y")+
  scale_color_hue(l=50, c=150)+theme(legend.position="none")+
  theme(axis.title=element_text(size=20),axis.text=element_text(size=20))

########################################

# LM

fit<-lm(y~x,data=d)
summary(fit)

########################################

# LMER INTERCEPT

fit<-lmer(y~x+(1|rand),data=d)
summary(fit)

########################################

# LMER INTERCEPT AND SLOPE

fit<-lmer(y~x+(x|rand),data=d)
summary(fit)

########################################

