
ggCaterpillar<-function (re, QQ = TRUE, likeDotplot = TRUE) 
  {
  f <- function(x) {
    pv <- attr(x, "postVar")
    cols <- 1:(dim(pv)[1])
    se <- unlist(lapply(cols, function(i) sqrt(pv[i, i, ])))
    ord <- unlist(lapply(x, order)) + rep((0:(ncol(x) - 1)) * 
                                            nrow(x), each = nrow(x))
    pDf <- data.frame(y = unlist(x)[ord], ci = 1.96 * se[ord], 
                      nQQ = rep(qnorm(ppoints(nrow(x))), ncol(x)), ID = factor(rep(rownames(x), 
                                                                                   ncol(x))[ord], levels = rownames(x)[ord]), ind = gl(ncol(x), 
                                                                                                                                       nrow(x), labels = names(x)))
    if (QQ) {
      p <- ggplot2::ggplot(pDf, ggplot2::aes(nQQ, y))
      p <- p + ggplot2::facet_wrap(~ind, scales = "free")
      p <- p + ggplot2::xlab("Standard normal quantiles") + 
        ggplot2::ylab("Random effect quantiles")
    }
    else {
      p <- ggplot2::ggplot(pDf, ggplot2::aes(ID, y)) + 
        ggplot2::coord_flip()
      if (likeDotplot) {
        p <- p + ggplot2::facet_wrap(~ind)
      }
      else {
        p <- p + ggplot2::facet_grid(ind ~ ., scales = "free_y")
      }
      p <- p + ggplot2::xlab("Subject") + ggplot2::ylab("Random effects")
    }
    p <- p + theme(axis.title=element_text(size=20),
                   axis.text.x=element_text(size=16),
                   axis.text.y=element_text(size=20),
                   strip.text = element_text(size=18))
    p <- p + theme(legend.position = "none")
    p <- p + ggplot2::geom_hline(yintercept = 0,linetype=2,size=1)
    p <- p + ggplot2::geom_errorbar(ggplot2::aes(ymin = y - 
                                                   ci, ymax = y + ci), 
                                    width = 0, colour = "black", size=1.3)
    p <- p + ggplot2::geom_point(ggplot2::aes(size = 1.2),
                                 shape=21,color="black",
                                 fill = "black",stroke=1)
    return(p)
  }
  lapply(re, f)
}